function Msg(value)
  reaper.ShowConsoleMsg(tostring(value) .. "\n")
  
end

function get_folders_file_type()

    retval_inputs, retvals_csv = reaper.GetUserInputs( "Set Folders & File Type (may take long time)", 3, "Set RealTracks Path (use [/]),extrawidth=100,Set RealDrums Path (use [/]),Set ext: wma wav m4a aiff etc..", "C:/bb/RealTracks,C:/bb/Drums,wma" )
    RTpath, RDpath, ext  = retvals_csv:match("([^,]+),([^,]+),([^,]+)")
    --Msg(RTpath.." "..RDpath.." "..ext)
    --user_offset = tonumber(user_offset)
    -- if not user_offset then user_offset = 0 end
    if not retval_inputs then goto finish2 end
    ext = "."..ext
    create_RTreapeaks()
    ::finish2::
  
end

function create_RTreapeaks()
  A,B=GetAllResourcePathFiles(RTpath,ext)
  
  rea_go =reaper.MB("There are "..tablelength(mediafiles).." RT Files this may take some time", "Attention",1)
  
  if rea_go == 2 then goto create_reapeaks end
  
 -- Msg("mediafiles "..tablelength(mediafiles))
  
  media_count = tablelength(mediafiles)
  for i = 1, media_count do
    if  reaper.file_exists( mediafiles[i] ) then
      --Msg("Create reapeak "..mediafiles[i])
      src = reaper.PCM_Source_CreateFromFile( mediafiles[i] )
      if not reaper.file_exists( mediafiles[i]..".reapeaks" ) then
        reaper.PCM_Source_BuildPeaks( src, 0 )
        --Msg("Create reapeak "..mediafiles[i])
        repeat
        per =  reaper.PCM_Source_BuildPeaks( src, 1 )
        until( per == 0 )
        reaper.PCM_Source_BuildPeaks( src, 2 )
        --Msg("Done "..mediafiles[i])
      end  
    end
  
  end
  
  ::create_reapeaks::
  
  create_RDreapeaks()
end

function create_RDreapeaks()
  A,B=GetAllResourcePathFiles(RDpath,ext)
  
  rea_go2 =reaper.MB("There are "..tablelength(mediafiles).." RD Files this may take some time", "Attention",1)
  
  if rea_go2 == 2 then goto create_reapeaks2 end
  
 -- Msg("mediafiles "..tablelength(mediafiles))
  
  media_count = tablelength(mediafiles)
  for i = 1, media_count do
    if  reaper.file_exists( mediafiles[i] ) then
      --Msg("Create reapeak "..mediafiles[i])
      src = reaper.PCM_Source_CreateFromFile( mediafiles[i] )
      if not reaper.file_exists( mediafiles[i]..".reapeaks" ) then
        reaper.PCM_Source_BuildPeaks( src, 0 )
        --Msg("Create reapeak "..mediafiles[i])
        repeat
        per =  reaper.PCM_Source_BuildPeaks( src, 1 )
        until( per == 0 )
        reaper.PCM_Source_BuildPeaks( src, 2 )
        --Msg("Done "..mediafiles[i])
      end  
    end
  
  end
  
  ::create_reapeaks2::
  
 
end


function GetAllResourcePathFiles(path,ext)
  reaper.EnumerateFiles(path, -1) -- refresh the cache,
  --Msg("Path "..path)                                                    -- after this, the filelist will be updated
  reaper.EnumerateSubdirectories( path, -1 )               -- to the most recent one
  mediafiles = {}
  
  index=0
  filelist={}
  while reaper.EnumerateFiles(path, index)~=nil do
    filelist[index+1]=reaper.EnumerateFiles(path, index)
    
    --Msg(folderlist[subdirindex+1].."\\"..filelist[index+1])
    --Msg(folderlist[subdirindex+1])
    --Msg(filelist[index+1])
    filext = filelist[index+1]:match("(%.%w+)$")
    --Msg(filext)
    
    if tostring(filext) == ext then
      --Msg(filext)
      --Msg(path.."\\"..folderlist[subdirindex+1].."\\"..filelist[index+1])
      --Msg(path.."\\"..folderlist[subdirindex+1].."\\"..filelist[index+1])
      table.insert(mediafiles, path.."\\"..filelist[index+1])
      
    end  
    index=index+1
    
  end
  --Msg("index "..index)
  local subdirindex=0
  local folderlist={}
  --folderlist[1]=reaper.EnumerateSubdirectories(path, 1)
  while reaper.EnumerateSubdirectories(path, subdirindex)~=nil do
  folderlist[subdirindex+1]=reaper.EnumerateSubdirectories(path, subdirindex)
  --Msg(path.."\\"..folderlist[subdirindex+1])
  -- get all current files in resourcepath
    --Msg("While Subs")
    local index=0
    --local filelist={}
    
    --while reaper.EnumerateFiles(path.."\\"..folderlist[subdirindex+1], index)~=nil do
    while reaper.EnumerateFiles(path.."\\"..folderlist[subdirindex+1], index)~=nil do
      filelist[index+1]=reaper.EnumerateFiles(path.."\\"..folderlist[subdirindex+1], index)
      --Msg("While Files")
      --Msg(folderlist[subdirindex+1].."\\"..filelist[index+1])
      --Msg(folderlist[subdirindex+1])
      --Msg(filelist[index+1])
      filext = filelist[index+1]:match("(%.%w+)$")
      --Msg(filext)
      
      if tostring(filext) == ext then
        --Msg(filext)
        --Msg(path.."\\"..folderlist[subdirindex+1].."\\"..filelist[index+1])
        --Msg(path.."\\"..folderlist[subdirindex+1].."\\"..filelist[index+1])
        table.insert(mediafiles, path.."\\"..folderlist[subdirindex+1].."\\"..filelist[index+1])
        
      end  
      index=index+1
    end
    subdirindex=subdirindex+1
  end
  return index, filelist, subdirindex, folderlist, mediafiles 
end


function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end


get_folders_file_type()

reaper.MB("Finished", "Attention",0)
